%$$ Pick a point and repeat evaluation many times to see variance
function Repeatability(p2max, p3max)
% p2max=1.5;
% p3max=0.8;
close all

%$ Select the parameters on which the optimization will run
%$$
starttime = tic;
numIters = 20;

params = Set_params();
params.player_type = 2; %1=continuous; 2=discrete
params.p2max = p2max;
params.p3max = p3max;
ppack.params = params;

%preallocation
SW_track = zeros(numIters, 1);
SW_SEM_track = zeros(numIters, 1);
AAR_track = zeros(numIters, 1);
AAR_SEM_track = zeros(numIters, 1);
DAR_track = zeros(numIters, 1);
DAR_SEM_track = zeros(numIters, 1);
DAM_track = zeros(numIters, 1);
DAM_SEM_track = zeros(numIters, 1);

UpdateEnv(params);
ppack = Load_mats(ppack);
ppack.useContL0 = 0;  %0=Discrete players; 1=continuous players
   
matlabpool open;
parfor i=1:numIters
    i
   
    datetime = int2str(datevec(now));      %current date and time
    datetime(ismember(datetime,' ')) = []; %remove spaces
    fnamee=[datetime '_Repeatability_p2max=' num2str(p2max) '_p3max=' ...
                    num2str(p3max)];
                
    [~,SW,SW_SEM, AAR, AAR_SEM, DAR, DAR_SEM, DAM, DAM_SEM] = TrainD1JandSave_SW2a(ppack,fnamee);
    close all

    %for tracking
    SW_track(i) = SW;
    SW_SEM_track(i) = SW_SEM;
    AAR_track(i) = AAR;
    AAR_SEM_track(i) = AAR_SEM;
    DAR_track(i) = DAR;
    DAR_SEM_track(i) = DAR_SEM;
    DAM_track(i) = DAM;
    DAM_SEM_track(i) = DAM_SEM;

    %below code is to pause the sim if needed
    statcode=exist('pausesim.rtf','file');
    if statcode==2,
        delete('pausesim.rtf');
        keyboard
    end
end
matlabpool close;

endtime = toc(starttime);

datetime = int2str(datevec(now));      %current date and time
datetime(ismember(datetime,' ')) = []; %remove spaces
fnamee=[datetime '_RepeatabilityFinal_p2max=' num2str(p2max) '_p3max=' ...
                num2str(p3max)];
save(fnamee);


fprintf('\nRepeatability Test Done!\n\n');



