close all
clear all


fs = filesep;
outdir = fullfile('Discrete', 'GenerateEnv', 'Output');
loaddir = fullfile('Discrete', 'Load');

fprintf('\nLoadAndRun Starting...');

%in_filenames = cellstr(ls('Batch/*.mat'));

listt= dir('Batch/*.mat');
in_filenames = cellstr({listt.name});

ppack.useContL0 = 0; % 1 if cont L0attacker is to be used.

for i = 1:numel(in_filenames)
    fprintf('\nProcessing file ');
    fprintf(in_filenames{i});
    fprintf('...');
    
    %loaded = load(strcat('Batch/',in_filenames{i}), 'params', 'filename');
    loaded = load(in_filenames{i}, 'params', 'filename');
    params = loaded.params;
    filename = loaded.filename;
    
    %Execute the scripts you want here:
    CPTfname = ['CPT-p2max' num2str(params.p2max,'%.3f') '-p3max' ...
        num2str(params.p3max,'%.3f')];
    CPTdir = fullfile('CPTs_calculated', CPTfname);
    if ~exist(CPTdir)
        mkdir(CPTdir)
        UpdateEnv(params);
        if ispc
            % Copy files from Output to CPTdir directory
            system(['copy ' outdir fs 'CPTs.mat ' CPTdir]);
            system(['copy ' outdir fs 'BinsOrSet.mat ' CPTdir]);
            system(['copy ' outdir fs 'ER.mat ' CPTdir]);
        elseif isunix
            % Copy files from Output to CPTdir directory
            system(['cp ' outdir fs 'CPTs.mat ' CPTdir]);
            system(['cp ' outdir fs 'BinsOrSet.mat ' CPTdir]);
            system(['cp ' outdir fs 'ER.mat ' CPTdir]);
        else
            fprintf('\nError: Operating system not supported. Please copy files manually.\n');
            assert(0);
        end
        addpath(genpath('CPTs_calculated'));
    end
    ppack.params = params;
    temp = load([CPTdir fs 'BinsOrSet']);
    ppack.BinsOrSet = temp.BinsOrSet;
    temp = load([CPTdir fs 'CPTs']);
    ppack.CPTs = temp.CPTs;
    temp = load([CPTdir fs 'ER']);
    ppack.ER = temp.ER;
    %ppack = Load_mats(ppack);
    %TrainA1JandSave(ppack,filename);
    %TrainD1JandSave(ppack,filename);
    TrainD1JandSave_SW2(ppack,filename);
    close all;
    statcode=exist('pausesim.rtf','file');
    if statcode==2,
        delete('pausesim.rtf');
        keyboard
    end
end

fprintf('\nLoadAndRun Done!\n\n');