%Train an L2 attacker using Jaakkola
function TrainA2JandSave( D1filename, ppack, filename )

if ( ~exist('D1filename'))
    [D1filename,D1pathname] = uigetfile('*.mat','Select L1Defender to load');
else
    D1pathname = ['Saves' filesep];
end
if ( ~exist('params') )
    ppack.params = Set_params();
    ppack = Load_mats(ppack);
end
if ( ~exist('filename') )
    filename = [];
end

close all;

% Modifying Scott's L0 Attacker to be used as policy initialization in
% Jaakoola training.
ScottLOAttinit = Scott_L0Att_forinit(ppack.params, ppack.BinsOrSet, ppack.CPTs);

fprintf('\nTrain L2 Attacker...')
method = 2; % 1: InitL0-NoObsNoTrain, 2: InitRand-NoObsFillL0
load( fullfile(D1pathname,D1filename) ); %L1 Defender against which training is done
tic
L2Attacker = Train_attacker_Jaakkola( L1Defender, ppack.params, ppack.BinsOrSet, ppack.CPTs, ppack.ER, 1, ScottLOAttinit, method);
toc

fprintf('\nSimulate L1 Defender vs L2 Attacker in continuous (does not exist)')
L2Attacker.exist = 0;
[D1A2states, D1A2defRewards, D1A2attRewards] = Simulate ( L1Defender, L2Attacker, 1, ppack );

fprintf('\nSimulate L1 Defender vs L2 Attacker in continuous (exist)')
L2Attacker.exist = 1;
[D1A2states, D1A2defRewards, D1A2attRewards] = Simulate ( L1Defender, L2Attacker, 1, ppack );

fprintf('\nSaving...');
filename = SaveDescription( SaveAllOpenPlots(filename), ppack );
save( fullfile('Saves', [filename '.mat']), 'L2Attacker');

fprintf('\nTrainA2JandSave Done!\n\n');