%Train an L1 defender using Jaakkola
function [defAvgReward, defAvgRewardSEM, SW, SW_SEM, defAvgNumMove] = TrainD1JandSave_SW3( ppack, filename )
fprintf('\nD1vsA0 Social Welfare Study, continuous training version...')

if ( ~exist('ppack') )
    ppack.params = Set_params();
    ppack.BinsOrSet = Save_BinsOrSet(ppack.params);
    temp = load ('Discrete/Load/ER.mat', 'ER');
    ppack.ER = temp.ER;
end
if ( ~exist('filename') )
    filename = [];
end

close all;

clear L0Attacker;
L0Attacker.mode = 3;
L0Attacker.thetaA = 0.07;
L0Attacker.useContL0 = 1;

fprintf('\nTrain L1 Defender...')
L1Defender = Train_defender_FQI( L0Attacker, ppack, 1);

% fprintf('\nSimulate L1 Defender vs L0 Attacker in continuous (exist)...')
% L0Attacker.exist = 1;
% [D1A0states, D1A0defRewards, D1A0attRewards] = Simulate ( L1Defender, L0Attacker, 0, ppack );

fprintf('Average reward in continuous...')
[defAvgReward, defAvgRewardSEM, attAvgReward, attAvgRewardSEM, ...
    defAvgNumMove, defAvgNumMoveSEM, AvgSocWelf, AvgSocWelfSEM] ... 
                = Average_rewards( L1Defender, L0Attacker, 100, false, ppack);

p2max = ppack.params.p2max
p3max = ppack.params.p3max
SW = AvgSocWelf
SW_SEM = AvgSocWelfSEM

% fprintf('\nSaving...');
% filename = SaveDescription( SaveAllOpenPlots(filename), ppack );
% save( fullfile('Saves',[filename '.mat']), 'L1Defender','ppack', ...
%     'defAvgReward','defAvgRewardSEM','attAvgReward', 'attAvgRewardSEM', ...
%     'defAvgNumMove', 'defAvgNumMoveSEM', 'AvgSocWelf', 'AvgSocWelfSEM');

fprintf('\nTrainD1JandSave_SW3 Done!\n\n');