function [ScottL0Attpi] = Scott_L0Att_forinit(params, BinsOrSet, CPTs)
% Converts Scott's L0 Attacker CPT to a usable form
%  to initialize Jaakola Attacker Policcy
% Inputs:    Attacker = defender
%            CPTs
%            BinsOrSet
%            Global parameters
% Output:    ScottL0Attpi = Scott's L0 Att CPT converted to an L0 Jaakola Policy

ScottL0Attpi = ones(BinsOrSet.N_V2,BinsOrSet.N_V3,params.N_statisticA,BinsOrSet.N_q3,BinsOrSet.N_q3)/(BinsOrSet.N_q3);

for i=1:BinsOrSet.N_V2
    for j=1:BinsOrSet.N_V3
        for k=1:params.N_statisticA
            for m=1:BinsOrSet.N_q3
                for n=1:BinsOrSet.N_q3
                    ScottL0Attpi(i,j,k,m,n) =  CPTs.ScottAttL0(n,i,m);
                end
            end
        end
    end
end

end


