function [ScottL0Defpi] = Scott_L0Def_forinit(params, BinsOrSet, CPTs)
% Converts Scott's L0 Defender CPT to a usable form
%  to initialize Jaakola Defender Policcy
% Inputs:    Defender = defender
%            CPTs
%            BinsOrSet
%            Global parameters
% Output:    ScottL0Defpi = Scott's L0 Def CPT converted to an L0 Jaakola Policy

ScottL0Defpi = ones(BinsOrSet.N_V1,BinsOrSet.N_V2,BinsOrSet.N_V3,params.N_statisticD,BinsOrSet.N_dX,BinsOrSet.N_dX)/(BinsOrSet.N_dX);

for i=1:BinsOrSet.N_V1
    for j=1:BinsOrSet.N_V2
        for k=1:BinsOrSet.N_V3
            for m=1:params.N_statisticD
                for n=1:BinsOrSet.N_dX
                    for p=1:BinsOrSet.N_dX
                        ScottL0Defpi(i,j,k,m,n,p) =  CPTs.ScottDefL0(p,i,j,k);
                    end
                end
            end
        end
    end
end

end




