%Use this file as example code snippets for calling Matlab code for 
%three-node circuit example

clc
clear all;
close all;

%Call this first to be able to call functions from sub-directories
addpath(genpath(pwd));

%Must first call these scripts to set parameters and load matrices
ppack.params = Set_params();
params.player_type = 2;  % 1 = continuous, 2 = discrete
ppack = Load_mats(ppack);

L0Attacker.mode = 3;
L0Attacker.thetaA = 0.07;

L0Defender.mode = 3;
L0Defender.thetaD = 0;

%%


fprintf('Train L1Defender...')
L1Defender = Train_defender_Jaakkola( L0Attacker, ppack.params, ppack.BinsOrSet, ppack.CPTs, ppack.ER );
fprintf('Simulate in discrete...')
[D1A0states_d, D1A0defRewards_d, D1A0attRewards_d] = Simulate_d(L1Defender, L0Attacker, 1, ppack.params, ppack.BinsOrSet, ppack.CPTs, ppack.ER)

%%


fprintf('Train L1Attacker...')
L1Attacker = Train_attacker_Jaakkola( L0Defender, ppack.params, ppack.BinsOrSet, ppack.CPTs, ppack.ER );
fprintf('Simulate in discrete...')
[D0A1states_d, D0A1defRewards_d, D0A1attRewards_d] = Simulate_d(L0Defender, L1Attacker, 1, ppack.params, ppack.BinsOrSet, ppack.CPTs, ppack.ER)
