%Use this file as example code snippets for calling Matlab code for 
%three-node circuit example

clear all;
close all;

%Call this first to be able to call functions from sub-directories
addpath(genpath(pwd));

%Must first call these scripts to set parameters and load matrices
ppack.params = Set_params();
params.player_type = 1;  % 1 = continuous, 2 = discrete
ppack = Load_mats(ppack);

L0Attacker.mode = 3;
L0Attacker.thetaA = 0.07;

L0Defender.mode = 3;
L0Defender.thetaD = 0;

%%


fprintf('Train L1Defender...')
L1Defender = Train_defender_SARSANN( L0Attacker, ppack );
fprintf('Simulate in continuous...')
[D1A0states, D1A0defRewards, D1A0attRewards] = Simulate(L1Defender, L0Attacker, 1, ppack)

%%

fprintf('Train L1Attacker...')
L1Attacker = Train_attacker_SARSANN( L0Defender, ppack );
fprintf('Simulate in continuous...')
[D0A1states, D0A1defRewards, D0A1attRewards] = Simulate(L0Defender, L1Attacker, 1, ppack)
