clc
clear
close all
GenParamList; % Desired parameters are set in GenParamList.m
for i=1:12
    LoadAndRun;
    %below code is to pause the sim if needed
    statcode=exist('pausesim.rtf','file');
    if statcode==2,
        delete('pausesim.rtf');
        keyboard
    end
end


% If it is desired to read mat files and process that information use below
% code
if (0)
    list_saves= dir('Saves/*.mat');
    in_filenames_saves = cellstr({list_saves.name});
    
    L0Attacker.mode = 3;
    L0Attacker.thetaA = 0.07;
    L0Attacker.useContL0 = 0;
    
    for i = 1:numel(in_filenames_saves)
        
        load(in_filenames_saves{i});
        p2max(i) = ppack.params.p2max;
        p3max(i) = ppack.params.p3max;
        ProbAttExist(i) = ppack.params.ProbAttExist;
        
        ppack.params.ProbAttExist = 0.0;
        fprintf('Average reward in continuos...')
        [defAvgReward, defAvgRewardSEM, attAvgReward, attAvgRewardSEM, ...
            defAvgNumMove, defAvgNumMoveSEM, AvgSocWelf, AvgSocWelfSEM ]...
            = Average_rewards( L1Defender, L0Attacker, 50, false,ppack);
        
        defAvgReward_plot0(i) = defAvgReward;
        defAvgRewardSEM_plot0(i) = defAvgRewardSEM;
        defAvgNumMove_plot0(i) = defAvgNumMove;
        defAvgNumMoveSEM_plot0(i) = defAvgNumMoveSEM;
        AvgSocWelf_plot0(i) = AvgSocWelf;
        AvgSocWelfSEM_plot0(i) = AvgSocWelfSEM;
        close all
        
        ppack.params.ProbAttExist = 1.0;
        fprintf('Average reward in continuos...')
        [defAvgReward, defAvgRewardSEM, attAvgReward, attAvgRewardSEM, ...
            defAvgNumMove, defAvgNumMoveSEM, AvgSocWelf, AvgSocWelfSEM ]...
            = Average_rewards( L1Defender, L0Attacker, 50, false,ppack);
        
        defAvgReward_plot1(i) = defAvgReward;
        defAvgRewardSEM_plot1(i) = defAvgRewardSEM;
        defAvgNumMove_plot1(i) = defAvgNumMove;
        defAvgNumMoveSEM_plot1(i) = defAvgNumMoveSEM;
        AvgSocWelf_plot1(i) = AvgSocWelf;
        AvgSocWelfSEM_plot1(i) = AvgSocWelfSEM;
        close all
        
    end
    close all;
end

if (0)
    ProbEx = [0.010 0.020 0.050 0.100 0.200 0.500 1.000];
    for i=1:size(ProbEx,2)
        ProbName = num2str(ProbEx(i),'%0.03f');
        list_saves= dir(['Saves_20128613811_IEEEPaperErrorBars_method2_NomialIC/*' ProbName '.mat']);
        in_filenames_saves = cellstr({list_saves.name});
        L0Attacker.mode = 3;
        L0Attacker.thetaA = 0.07;
        L0Attacker.useContL0 = 0;
        
        for j = 1:numel(in_filenames_saves)
            load(in_filenames_saves{j});
            for k=1:2
                ppack.params.ProbAttExist = k-1;
                fprintf('Average reward in continuos...')
                [defAvgReward, defAvgRewardSEM, attAvgReward, attAvgRewardSEM, ...
                    defAvgNumMove, defAvgNumMoveSEM, AvgSocWelf, AvgSocWelfSEM ]...
                    = Average_rewards( L1Defender, L0Attacker, 50, false,ppack);
                defAvgReward_plot(j,k) = defAvgReward;
                defAvgRewardSEM_plot(j,k) = defAvgRewardSEM;
                defAvgNumMove_plot(j,k) = defAvgNumMove;
                defAvgNumMoveSEM_plot(j,k) = defAvgNumMoveSEM;
            end
        end
        defAvgReward_train(i,1) = mean(defAvgReward_plot(:,1));
        defAvgRewardSD_train(i,1) = sqrt(var(defAvgReward_plot(:,1)));
        defAvgReward_train(i,2) = mean(defAvgReward_plot(:,2));
        defAvgRewardSD_train(i,2) = sqrt(var(defAvgReward_plot(:,2)));
        
        defAvgNumMove_train(i,1) = mean(defAvgNumMove_plot(:,1));
        defAvgNumMoveSD_train(i,1) = sqrt(var(defAvgNumMove_plot(:,1)));
        defAvgNumMove_train(i,2) = mean(defAvgNumMove_plot(:,2));
        defAvgNumMoveSD_train(i,2) = sqrt(var(defAvgNumMove_plot(:,2)));
        
        %below code is to pause the sim if needed
        statcode=exist('pausesim.rtf','file');
        if statcode==2,
            delete('pausesim.rtf');
            keyboard
        end
    end
end

datetime = int2str(datevec(now));      %current date and time
datetime(ismember(datetime,' ')) = []; %remove spaces
fnamee=[datetime '_IEEEPaperErrorBars'];
save(fnamee);

figure
errorbar(defAvgReward_train(:,1),defAvgRewardSD_train(:,1));
title('0% Attacker Existance');

figure
errorbar(defAvgReward_train(:,2),defAvgRewardSD_train(:,2));
title('100% Attacker Existance');

figure
plot(ProbEx,defAvgReward_train(:,1))
title('0% Attacker Existance')

figure
plot(ProbEx,defAvgReward_train(:,2))
title('100% Attacker Existance')



% %plotting a 3d graph
% j=1;
% for i=1:length(ProbAttExist)
%     if ProbAttExist(i)==1   %for cases where attacker always exists
%         p2max_cond(j)=p2max(i);
%         p3max_cond(j)=p3max(i);
%         defAvgReward_plot_cond(j)=defAvgReward_plot(i);
%         j = j+1;
%     end
% end
% Unsorted3d = [p3max_cond' p2max_cond' defAvgReward_plot_cond'];
% Sorted3d = sortrows(Unsorted3d);
% 
% [X,Y] = meshgrid(Sorted3d(:,1),Sorted3d(:,2));
% Z = griddata(Sorted3d(:,1),Sorted3d(:,2),Sorted3d(:,3), X, Y);
% figure
% surf(X,Y,Z,'FaceColor','red','EdgeColor','green')
% camlight left; lighting phong
% figure
% mesh(X,Y,Z,'Edgecolor','black')

%plotting a 2d graph

% j=1;
% for i=1:length(ProbAttExist)
%     if ProbAttExist(i)==1 && ...  %for cases where attacker always exists
%             p2max(i)==1.4         %and p2max = 1.4, p3max=0.8
%         p3max_cond2d(j)=p3max(i);
%         %p2max_cond2d(j)=p2max(i);
%         defAvgReward_plot_cond2d(j) = defAvgReward_plot(i);
%         defAvgRewardSEM_plot_cond2d(j) = defAvgRewardSEM_plot(i);
%         defAvgNumMove_plot_cond2d(j) = defAvgNumMove_plot(i);
%         defAvgNumMoveSEM_plot_cond2d(j) = defAvgNumMoveSEM_plot(i);
%         AvgSocWelf_plot_cond2d(j) = AvgSocWelf_plot(i);
%         AvgSocWelfSEM_plot_cond2d(j) = AvgSocWelfSEM_plot(i);        
%         j = j+1;
%     end
% end
% Unsorted2d = [p3max_cond2d' AvgSocWelf_plot_cond2d' AvgSocWelfSEM_plot_cond2d' ...
%               defAvgReward_plot_cond2d' defAvgRewardSEM_plot_cond2d' ...
%               defAvgNumMove_plot_cond2d' defAvgNumMoveSEM_plot_cond2d' ];
% Sorted2d = sortrows(Unsorted2d);
% figure
% hold on
% errorbar(Sorted2d(:,1),Sorted2d(:,2), Sorted2d(:,3),'-*r')
% errorbar(Sorted2d(:,1),Sorted2d(:,4), Sorted2d(:,5),'-*b')
% errorbar(Sorted2d(:,1),Sorted2d(:,6), Sorted2d(:,7),'-*k')
% hold off

%
%
%
%
%


