%$ Modified by Yildiray Yildiz on 09/27/12
%-modified the "AttMove_prev" input as a cell array
%and modified the output vector accordingly
%-commented out the conventional StatA calculation (and dq3) since it uses 
%one dimensional move space. Needs to be recalculated for multidimensional
%move space. For now "1" is assigned as it's value. (MemA.StatA = 1)

function MemA = Sample_MA( PGS, MemA_prev, AttMove_prev, params )
    gamma = params.SampleMA_gamma;
    x2 = params.x2;
    V0 = params.V0;
    dV = params.dV;
    p3max = params.p3max;
    M = params.M;
    
    MemA.AttMove_prev = AttMove_prev;
    
    MemA.V2 = PGS.getAttribute(2, PowerGridSystem.VOLTAGE_MAGNITUDE);
    MemA.V3 = PGS.getAttribute(3, PowerGridSystem.VOLTAGE_MAGNITUDE);
    
    MemA.V3_prev = MemA_prev.V3;      % V3_@ t-1
    MemA.AttMove_prev = AttMove_prev;      %AA @ t-1
    
    dV3 = MemA.V3_prev - MemA_prev.V3_prev;
%    dq3 = p3max/M*(MemA.AttMove_prev - MemA_prev.AttMove_prev);
    
    % Compute the statistic of attacker @ t
 %   MemA.StatA = gamma * MemA_prev.StatA...
 %               + sign(floor((dV3-dq3*x2/V0)/(dV/V0)));
 MemA.StatA = 1;
 
    MemA.vec = [MemA.V2; MemA.V3; MemA.StatA; MemA.AttMove_prev{1}; ...
        MemA.AttMove_prev{2}];
end