%Modified by Yildiray Yildiz on 09/27/12
%made the move dX a cell array and modified the output as:
% dX{1} = ..;
% dX{2} = 0;

function dX = Scott_Def( Defender, MemD, params )
%Simulate the defender's policy
%Inputs:    Defender = defender
%           MD = defender's memory
%Output:    dX = Defender's move

V0 = params.V0;
dV = params.dV;
N = params.N;
props = Defender.GetProperties();

x = round((MemD.V1-V0)*N/dV);   %invert equation to get x from V1
V2 = MemD.V2;
V3 = MemD.V3;

z=((V2+V3)/2-V0)/(dV/N);
PiD_normal =  -sign(z) * sign( floor( abs(z) ));
PiD_safe = -sign(x);

dX{1} = sign((1-props.thetaD)*PiD_normal + props.thetaD*PiD_safe);
dX{2} = 0;

end
