
// *************************************************************************
//	LibNFG: Net-form game library
//
//	Author:		Ritchie Lee
//
//  Copyright 2011 United States Government as represented by the Administrator 
//  of the National Aeronautics and Space Administration.  All Rights Reserved.  
//  Licensed under the Apache License, Version 2.0 (the "License"); you may not 
//  use this file except in compliance with the License.  You may obtain a copy 
//  of the License at http://www.apache.org/licenses/LICENSE-2.0
//  Unless required by applicable law or agreed to in writing, software 
//  distributed under the License is distributed on an "AS IS" BASIS, WITHOUT 
//  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the 
//  License for the specific language governing permissions and limitations 
//  under the License.
//
//	Revision Log
//
//	Username	Date		Description
//	-------------------------------------------------------
//	rlee		20110907	Created
//
// *************************************************************************

#include "alg_levelkrl.h"

// *************************************************************************
// *************************************************************************
alg_LevelKRL::alg_LevelKRL( void )
{
}
// *************************************************************************
// *************************************************************************
alg_LevelKRL::~alg_LevelKRL ( void )
{
}
// *************************************************************************
// *************************************************************************
nfg_Episode alg_LevelKRL::Simulate( IBayesNet& ibnet )
{
	nfg_Episode episode;
	
	// Sample t0
	//episode.push_back( 
	
	// Other time steps
	for ( unsigned int t = 1; t < ibnet.Get_num_steps(); t++ )
	{
		episode.push_back( Sample_slice( ibnet, episode.at(0)) );
	}

	return episode;
}
// *************************************************************************
// *************************************************************************
nfg_Slice alg_LevelKRL::Sample_slice( IBayesNet& ibnet, const nfg_Slice& sliceT )
{
	// Do forward sampling on the slice given the previous slice

	// To hold next time slice
	nfg_Slice sliceTp1;
	
	// Sample each vertex in the slice in order
	//foreach( nfg_Vertex vi, vertices( ibnet.Get_graph()) )
	//{
		//nfg_Vecs paVecs;
		// Get interconnect parents
		//paVecs = Get_interconnect_parents( optInst, vi );

		// Append in-slice parents
		//nfg_Vecs inslicePaVecs = Get_inslice_parents();
		//paVecs.insert( paVecs.end(), inslicePaVecs.begin(), inslicePaVecs.end() );

		// Sample vertex
		//sliceTp1.push_back(	ibnet.Get_cpd(vi)->Sample_node(paVecs) );	
	//}

	return sliceTp1;
}
// *************************************************************************
// *************************************************************************
nfg_Vecs alg_LevelKRL::Get_inslice_parents( IBayesNet& ibnet, 
										   const nfg_OptInst& optInst, 
												const nfg_Vertex& v )
{
	nfg_Vecs paVecs;
	//	Loop through each parent of v
	//foreach ( nfg_Vertex vi, inv_adjacent_vertices(v, ibnet.Get_graph()) )
	//{
		// Make sure it is defined
		//bassert ( optInst.at(vi) );

		// add it to the list of parent vecs in order of vertex id
		//paVecs.push_back( *optInst.at(vi) );
	//}

	return paVecs;
}
// *************************************************************************
// *************************************************************************
nfg_Vecs alg_LevelKRL::Get_interconnect_parents( const nfg_OptInst& optInst, 
														const nfg_Vertex& v )
{
	return nfg_Vecs();
}

