
// *************************************************************************
//	LibNFG: Net-form game library
//
//	Author:		Ritchie Lee
//
//  Copyright 2011 United States Government as represented by the Administrator 
//  of the National Aeronautics and Space Administration.  All Rights Reserved.  
//  Licensed under the Apache License, Version 2.0 (the "License"); you may not 
//  use this file except in compliance with the License.  You may obtain a copy 
//  of the License at http://www.apache.org/licenses/LICENSE-2.0
//  Unless required by applicable law or agreed to in writing, software 
//  distributed under the License is distributed on an "AS IS" BASIS, WITHOUT 
//  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the 
//  License for the specific language governing permissions and limitations 
//  under the License.
//
//	Revision Log
//
//	Username	Date		Description
//	-------------------------------------------------------
//	rlee		20110328	Created
//
// *************************************************************************

#include "cpd_decision.h"

using namespace nfg;

// *************************************************************************
// *************************************************************************
cpd_Decision::cpd_Decision( Player& player )
{
	//	Get the utility function from the player
	m_fo_Get_util			= player.Get_fo_of_Get_util();
}
// *************************************************************************
// *************************************************************************
cpd_Decision::~cpd_Decision ( void )
{
}
// *************************************************************************
// *************************************************************************
double	cpd_Decision::Get_util ( const nfg_Inst& instVecs )
{
	//	Call get_util from member function object
	return m_fo_Get_util( instVecs );
}
// *************************************************************************
// *************************************************************************
double cpd_Decision::Get_probability ( const nfg_Vec& outVec, const nfg_Vecs& inputVecs )
{	
	//	The probability cancels out numerator and denominator (see proof in [Lee11], 
	//	so just set it to 1
	return 1.0;
}

