
// *************************************************************************
//	LibNFG: Net-form game library
//
//	Author:		Ritchie Lee
//
//  Copyright 2011 United States Government as represented by the Administrator 
//  of the National Aeronautics and Space Administration.  All Rights Reserved.  
//  Licensed under the Apache License, Version 2.0 (the "License"); you may not 
//  use this file except in compliance with the License.  You may obtain a copy 
//  of the License at http://www.apache.org/licenses/LICENSE-2.0
//  Unless required by applicable law or agreed to in writing, software 
//  distributed under the License is distributed on an "AS IS" BASIS, WITHOUT 
//  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the 
//  License for the specific language governing permissions and limitations 
//  under the License.
//
//	Revision Log
//
//	Username	Date		Description
//	-------------------------------------------------------
//	rlee		20120710	Created
//
// *************************************************************************

#include "ibayesnet.h"

// *************************************************************************
// *************************************************************************
IBayesNet::IBayesNet( const string ibnetName, BayesNet& baseBNet, 
				BayesNet& kernelBNet,
				const nfg_Edges& base2kernelEdges,
				const nfg_Edges& kernel2kernelEdges,
				const unsigned int numSteps )
{
	// TODO: Check interconnects
	// TODO: Branch nodes not tested.  Unknown behavior.

	m_ibnetName					= ibnetName;
	m_baseBNet					= baseBNet;
	m_base2kernelEdges			= base2kernelEdges;
	m_kernelBNet				= kernelBNet;
	m_kernel2kernelEdges		= kernel2kernelEdges;
	m_numSteps					= numSteps;
}
// *************************************************************************
// *************************************************************************
IBayesNet::~IBayesNet ( void )
{
}
// *************************************************************************
// *************************************************************************
void IBayesNet::Set_player_policy ( int playerId, nfg_SampleFunc fo_policy )
{
	m_iplayers.at(playerId).Set_policy( fo_policy );
}
//// *************************************************************************
//// *************************************************************************
//nfg_Episode IBayesNet::Forward_sample ( void )
//{
//	// Not handling these cases at the moment...
//	bassert( nTimeSteps > 1 );
//
//	nfg_Episode outEp; 
//	
//	// Sample the base bnet
//	outEp.push_back( m_baseBNet.Forward_sample() );
//	
//	// Sample the first kernel bnet
//	outEp.push_back( Forward_sample_first_kernel_bnet( outEp ) );
//
//	// Sample the rest of the bnet
//	for ( int t = 2; t < nTimeSteps; t++ )
//	{
//		outEp.push_back( Forward_sample_kernel_bnet( outEp ) );
//	}
//
//}
//// *************************************************************************
//// *************************************************************************
//nfg_Vec IBayesNet::Sample_node ( void )
//{
//	
//}


