
// *************************************************************************
//	LibNFG: Net-form game library
//
//	Author:		Ritchie Lee
//
//  Copyright 2011 United States Government as represented by the Administrator 
//  of the National Aeronautics and Space Administration.  All Rights Reserved.  
//  Licensed under the Apache License, Version 2.0 (the "License"); you may not 
//  use this file except in compliance with the License.  You may obtain a copy 
//  of the License at http://www.apache.org/licenses/LICENSE-2.0
//  Unless required by applicable law or agreed to in writing, software 
//  distributed under the License is distributed on an "AS IS" BASIS, WITHOUT 
//  WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the 
//  License for the specific language governing permissions and limitations 
//  under the License.
//
//	Revision Log
//
//	Username	Date		Description
//	-------------------------------------------------------
//	rlee		20110227	Created
//
// *************************************************************************

#ifndef INCLUDED_NET_STUDENT_H
#define INCLUDED_NET_STUDENT_H

#include "bayesnet.h"

/**
 * "Student" example. Figure 12.1 from Koller's Probabilistic Graphical Models.
 * All discrete chance nodes. No decision nodes.  No players.
 *	Demonstrates approximate inference using Monte Carlo. Topological sort function.
 */
class net_Student
{
	// Make convenient labels for the vertices
	enum { D, I, G, L, S, N };

public:
	/**
	 * Run: Execute example sequence
	 */
	static void Run ( void );
	/**
	 * Analysis1: Performs a series of analyses based on a bnet
	 *	bnet: nfg object
	 */
	static void Analysis1 ( BayesNet& bnet );
};

#endif

